/* $Id: makedist.c,v 1.1 1993/04/02 20:28:06 idl Exp $ */

/************************************************************************/
/*									*/
/*	makedist.c							*/
/*									*/
/*	Copyright (c) 1992, Research Systems Inc.  All rights reserved.	*/
/*									*/
/*	Generate data in IDL, print the contents.			*/
/*									*/
/************************************************************************/

#include        <stdio.h>
#include        <ctype.h>
#include        <rpc/rpc.h>
#include	"export.h"
#include	"rpc_idl.h"
#include	<math.h>

static	void	print_it( var )
    varinfo_t * var;
{
    ARRAY	*arr;
    float	*data;
    int		i;
    
    /*	We assume that we are printing a 2-D array of floating point	*/
    /*	values. We do some minimal checking to make sure.		*/

    if(var->Variable->type != TYP_FLOAT ||
       (var->Variable->flags & V_ARR) == 0)
	return;
    arr		= var->Variable->value.arr;
    data	= (float *)arr->data;

    printf("0000:");
    for( i = 0; i < arr->n_elts; ++i ) {
	printf(" %10.5f", data[i] );

	/*	put four elements on every line			*/
	
	if( (i & 3) == 3 && i+1 < arr->n_elts )
	    printf("\n%04d:", i+1 );
    }
    printf("\n");
}

main(argc, argv)
     int	argc;
     char	*argv[];
{
    char		*hostname	= NULL;
    CLIENT		* client;
    varinfo_t		dist;

    /*	Set up connection with IDL server. If there is a command	*/
    /*	line argument, assume that it is the hostname where the IDL	*/
    /*	server is running.						*/

    if(argc == 2)
	hostname	= argv[1];
    
    client	= register_idl_client( 0, hostname, NULL );

    if( client == NULL )
	printf("Can't find server.\n"), exit(1);

    /*	Generate data							*/

    if(send_idl_command( client, "X=COS(DIST(40))" ) != 1 ) {
	printf("Problems running dist()\n");
	exit(1);
    }

    /*	Get the array							*/

    bzero(&dist, sizeof(dist));
    if( get_idl_variable( client, "X", &dist, 0 ) != 1 ) {
	printf("Problems getting variable X\n");
	exit(1);
    }

    print_it( &dist );

    /*	Disconnect from server						*/
    unregister_idl_client( client );
}
